LeetCode 237. Delete Node in a Linked List

237. Delete Node in a Linked List
Write a function to delete a node (except the tail) in a singly linked list, given only access to that node.

Supposed the linked list is 1 -> 2 -> 3 -> 4 and you are given the third node with value 3, the linked list should become 1 -> 2 -> 4 after calling your function.

分析:因为删除结点本来的步骤是找到当前结点的前一个结点,然后修改前一个结点的 next 指针指向。现在只知道当前要删除的结点,而不知道要删除结点的前一个结点,所以可以通过修改当前要删除结点的值,然后将当前结点指针指向 next 的 next (也就是变成了把后一个结点的值赋给当前结点,然后删除要删除结点的下一个结点),达到删除结点的目的~

 

LeetCode 226. Invert Binary Tree

Invert a binary tree.

4
/ \
2 7
/ \ / \
1 3 6 9
to
4
/ \
7 2
/ \ / \
9 6 3 1
Trivia:
This problem was inspired by this original tweet by Max Howell:
Google: 90% of our engineers use the software you wrote (Homebrew), but you can’t invert a binary tree on a whiteboard so fuck off.

 

LeetCode 111. Minimum Depth of Binary Tree

Given a binary tree, find its minimum depth.

The minimum depth is the number of nodes along the shortest path from the root node down to the nearest leaf node.

LeetCode 104. Maximum Depth of Binary Tree

Given a binary tree, find its maximum depth.

The maximum depth is the number of nodes along the longest path from the root node down to the farthest leaf node.

LeetCode 292. Nim Game

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

思路:
设甲乙一人一次为一轮。进行了很多轮之后,让甲选的时候,如果是1,2,3那就可以通过。如果是4一定不能赢,所以如果是5,6,7可以想办法分别取1,2,3让乙来一定不能赢,所以5,6,7甲是可以赢的。
如果是8,则无论甲选任何个数,都能让乙来面临7,6,5这些必赢的选项所以甲一定输。
如果是9,10,11,则甲可以通过让乙来面临8来一定输。
如果是12,则甲无论选取任何个数,都能让乙面临9,10,11这样的一定可以赢的数字,所以12让甲必定输。
以此类推发现规律,在4或者4的倍数的时候,甲无论怎样一定输。
所以就简单一句:return n % 4